clc; % ekrani sil.
clear all; % hafiza temizle
close all; % a?ik pencereleri kapatir
warning off

I1=imread('peppers.png');

[en, boy, kanal]=size(I1);

fprintf('Resmin satir sayisi = %d piksel\n',en);
fprintf('Resmin sutun sayisi = %d piksel \n',boy);
fprintf('Resmin kanal sayisi = %d \n',kanal);

figure; 
imshow(I1)

R1=I1(:,:,1);
G1=I1(:,:,2);
B1=I1(:,:,3);

figure; imshow(R1); title('Kirmizi Renk Kanali')

figure; imshow(B1); title('Mavi Renk Kanali');

% Bayer Tipi Ornekleme Yapalim
R1b=zeros(en,boy);
G1b=zeros(en,boy);
B1b=zeros(en,boy);

% BAYER tipi orneklenmis Kirmizi, Yesil ve Mavi Kanal
for satir=1:2:en
    for sutun=1:2:boy
        
        R1b(satir,sutun)=R1(satir,sutun);
        
        B1b(satir+1,sutun+1)=B1(satir+1,sutun+1);
        
        G1b(satir,sutun+1)=G1(satir,sutun+1);
        
        G1b(satir+1,sutun)=G1(satir+1,sutun);
        
    end
end

figure; 
imshow(uint8(R1b)); title('Orneklenmis Kirmizi Kanal');

I2=zeros(en,boy,kanal);

I2(:,:,1)=R1b;
I2(:,:,2)=G1b;
I2(:,:,3)=B1b;

figure;
imshow(uint8(I2));
title('BAYER ornekleme sonucu');

MR=[0.25 ,0.5 , 0.25 ;0.5 , 1 , 0.5; 0.25, 0.5, 0.25 ];
MB=[0.25 ,0.5 , 0.25 ;0.5 , 1 , 0.5; 0.25, 0.5, 0.25 ];
MG=[0 ,0.25 , 0 ;0.25 , 1 , 0.25; 0, 0.25, 0 ];

disp('Kirmizi Filtresi')
disp(MR)

R2=filter2(MR,R1b);
G2=filter2(MG,G1b);
B2=filter2(MB,B1b);

%figure; 
%subplot(1,2,1);imshow(uint8(R1b)); title('Orneklenmis Kirmizi')
%subplot(1,2,2);imshow(uint8(R2)); title('Enterpolasyon Sonrasi Kirmizi')

I3=zeros(en,boy,kanal);
I3(:,:,1)=R2;
I3(:,:,2)=G2;
I3(:,:,3)=B2;

%figure;
%imshow(uint8(I3));
%title('BAYER ornekleme sonucu');

figure; 
subplot(1,2,1);imshow(uint8(I2)); title('Orneklenmis Imge')
subplot(1,2,2);imshow(uint8(I3)); title('Enterpolasyon Sonrasi Imge')

figure; 
subplot(1,2,1);imshow(uint8(I1)); title('Orjinal Imge')
subplot(1,2,2);imshow(uint8(I3)); title('Enterpolasyon Sonrasi Imge')














